
:- module(debug_write,[debug_format/3,
		       debug_do_and_format/4,
		       debug_once/1,
		       verbosity/1]).

:- meta_predicate debug_once(+,:).

:- dynamic verbosity/1.

verbosity(1).

debug_format(Level,Format, Arguments) :-
	verbosity(V),
	V >= Level, !,
	format(user_error,Format, Arguments).
debug_format(_, _, _).

debug_do_and_format(Level, Goal, Format, Arguments) :-
	verbosity(V),
	V >= Level, !,
	(
	  call(Goal)
	->
	  format(user_error,Format, Arguments)
	;
	  true
	).
debug_do_and_format(_, _, _, _).

debug_once(Level,Goal) :-
	verbosity(V),
	V >= Level, !,
	once(Goal).
debug_once(_, _).

