#!/bin/sh
# directory where logs and theories will be stored
PREFIX=trains100_threshold1_01_minpos10_em
#background file name is $BG.b
BG="trainsDP"
# number of nodes before sayu moves to a different seed
NODES=50000
CLAUSE_LENGTH=5
# change to use your own YAP and Aleph
#1 start from empty network (initial sayu)
USE_AGGS=4
# naive bayes, tan, majority vote
#     public static final int NB = 0;
#     public static final int TAN = 1;
#     public static final int FULL_TAN = 3;
#     public static final int VOTE = 2;
CLASSIFIER_TYPE=1
# scoring method: accuracy, PR AUC, ROC AUC, conditional likelihood, etc.
#     public static final int ACC = 0;
#     public static final int PR_AREA = 1;
#     public static final int ROC_AREA = 2;
#     public static final int CLL = 3;
#     public static final int MSQE = 4;
#     public static final int X_ENT = 5;
#     public static final int UPLIFT = 6;
SCORING_METHOD=6
#
# default threshold for PR_AREA
#
MIN_THRESHOLD=0.2
# YAP install in this system
YAP=/u/vitor/Yap/bins/java/yap
# SEARCH_MODE em, eager
SEARCH_MODE=em

NUM_TRAINS=100
USE_NOISE=false
NOISE_POSTFIX=""
NOISE_AMOUNT=0
if $USE_NOISE ; then
  NOISE_POSTFIX="_n"
  NOISE_AMOUNT=10
fi
mkdir -p "$PREFIX"

for i in `seq $1 $2`; do
  # first see if this group of trains exists
  if [ ! -f trains/DP"$i"_1_1000.bk ]
  then
    continue
  fi
  PROB_FILE="$PREFIX"/probs_"$i".yap
  IPREFIX="$PREFIX"_"$i"_
  IFILE="$FILE"run"$i"  
  BK="$IPREFIX"_"$BG"
  CORRELATION_FILE=acorrs_"$i".yap
  BKTARGET=DP"$i"_1_1000.bk
  BKOTHER=DP"$i"_2_1000.bk
  RULEFILE="$PREFIX"/DP"$i"_"$NUM_TRAINS$NOISE_POSTFIX".hyp
  ln -sf "$BG".b "$BK".b

  cat trains/DP"$i"_1_"$NUM_TRAINS$NOISE_POSTFIX".f > "$IPREFIX"train0.f
  ln -sf "$IPREFIX"train0.f "$IPREFIX"tune0.f
  ln -sf "$IPREFIX"train0.f "$IPREFIX"test0.f
  cat trains/DP"$i"_1_"$NUM_TRAINS$NOISE_POSTFIX".f \
      trains/DP"$i"_2_"$NUM_TRAINS$NOISE_POSTFIX".f > "$IPREFIX"train.f
  ln -sf "$IPREFIX"train.f "$IPREFIX"tune.f
  ln -sf "$IPREFIX"train.f "$IPREFIX"test.f
  
  cat trains/DP"$i"_1_"$NUM_TRAINS$NOISE_POSTFIX".n > "$IPREFIX"train0.n
  ln -sf "$IPREFIX"train0.n "$IPREFIX"tune0.n
  ln -sf "$IPREFIX"train0.n "$IPREFIX"test0.n
  cat trains/DP"$i"_1_"$NUM_TRAINS$NOISE_POSTFIX".n \
      trains/DP"$i"_2_"$NUM_TRAINS$NOISE_POSTFIX".n > "$IPREFIX"train.n
  ln -sf "$IPREFIX"train.n "$IPREFIX"tune.n
  ln -sf "$IPREFIX"train.n "$IPREFIX"test.n

  ln -sf "$IPREFIX"train.f "$BK".f
  ln -sf "$IPREFIX"train.n "$BK".n
#cat <<EOF
nohup "$YAP" -l "$HOME"/ILP/sayu/aleph.yap  << EOF > "$PREFIX"/LOG.$i 2>&1 &
%yap_flag(gc_trace,verbose).
% saying which subset should be first thing,
read_all('$BK').
consult('trains/$BKTARGET').
consult('trains/$BKOTHER').
set(recordfile,'$PREFIX/$BG$i.trace').
vsc_set(sayu_dump_file('$PROB_FILE')).
vsc_set(sayu_min_recall_in_area($MIN_THRESHOLD)).
vsc_set(sayu_classifier_type($CLASSIFIER_TYPE)).
vsc_set(sayu_scoring_method($SCORING_METHOD)).
%vsc_set(sayu_start_seeds(200)).
vsc_set(sayu_prefix('$IPREFIX')).
set(nodes,$NODES).
set(verbosity,0).
set(clauselength,$CLAUSE_LENGTH).
set(noise,$NOISE_AMOUNT).
vsc_set(sayu_mode($SEARCH_MODE)).
vsc_set(max_step(20)).
vsc_set(sayu_output_theory('$RULEFILE')).
sayu_compute_strata0_sizes($IPREFIX).
Z is 3600, % 1 hour time limit
statistics(runtime,[T,_]), induce_sayu_timed(Z), statistics(runtime,[Tf,_]), D is Tf-T, format('ILP run took ~d msec.~n',[D]).


EOF
# rm -f "$BK".[bfn] "$IPREFIX"train.[fn] "$IPREFIX"tune.[fn] "$IPREFIX"test.[fn] "$IPREFIX"train0.[fn] "$IPREFIX"tune0.[fn] "$IPREFIX"test0.[fn]
done
