package sayu;
/**
   @author Jesse Davis
   12/5/03

       This class is used to represent the result of classification
       attempt of a feature vector in a compact manner. It only
       represents binary classification problems.  It represents each
       example as the probability of being the 'positive class' and
       the examples true classification.
 */
public class ClassSort implements Comparable{

    //the probability that this example is the positive class.
    private double prob;
    //the true classification of this example.
    private int classification;

    private int count;
    
    private int hashCode; 
    /**
       This class is used to represent the result of classification
       attempt of a feature vector in a compact manner. It only
       represents binary classification problems.  It represents each
       example as the probability of being the 'positive class' and
       the examples true classification.
       @param prob the probability that this example is the positive class.
       @param classification the true classification of this example.
     */
    public ClassSort(double prob, int classification){
        this.prob = Utils.round(prob, 5);
	hashCode = (classification == 1) ? (int)(100000 * this.prob) : (int)(-100000 * this.prob);
        this.classification = classification;
	count = 1;
    }//end of method ClassSort

    /**
       @return the true classification of this example.
     */
    public int getClassification(){
        return classification;
    }//end of method getClassification()


    /**
       @return the probability that this example is the positive class.
     */
    public double getProb(){
        return prob;
    }//end of method getProb();

    public int getCount(){
	return count;
    }

    public void setCount(int newCount){
	count = newCount;
    }
    /**
       @param o is of type ClassSort
       @return -1 if o has a higher probability than this.  0 if o and this have the same probability.  1 if this has a higher probability than o.
     */
    public int compareTo(Object o){
        double tmpProb = ((ClassSort)o).getProb();
        if (prob < tmpProb){
            return -1;
        }
        else if (prob > tmpProb){
            return 1;
        }
        else{
            int tmpClass = ((ClassSort)o).getClassification();
            if (tmpClass == classification){
                return 0;
            }
            else if (classification > tmpClass){
                return -1;
            }
            else{
                return 1;
            }
        }
    }//end of method compareTo

    public int hashCode(){
	//System.out.println("has code is " + hashCode + " " + classification);
	return hashCode;
    }

    public boolean equals(Object obj){
	int comp = compareTo(obj);
	if (comp == 0){
	    return true;
	}
	else{
	    return false;
	}
    }
}//end of method ClassSort
