package sayu;
/**
   @author jesse davis
   (c) June 2003
   

   This class holds an example from data.  It holds the values of all the known
   attributes.
*/

public class DataElement{

    //NOTE THIS DATAMEMBER ISN'T initialized
    private String classification; //the final classification of this example

    /*
      holds the values of the atrributes if at least one of the attributes
      has non-binary values. stores a missing value as the empty string "".
    */
    private String[] attribVals;  


    private double[] conVals;

    public DataElement(String[] vals){
	this.attribVals = vals;
    }

    public DataElement(int numAttributes){
	    
	    attribVals = new String[numAttributes];
	    conVals = new double[numAttributes];
    }

    /*
      That is the final classificaiotn of this example/datapoint.
    */
    public String getClassification(){
	return classification;
    }

    /*
      this sets the classification of this example.
    */
    public void setClass(String classification){
	this.classification = classification;
    }

    /**
       @return true if added, false if pos<0 || pos >= attribVals.length
     */
    public boolean addAttribute(String attrib, int pos){
	if ((pos <0) || (pos >= attribVals.length))
	    return false;
	else{
	    attribVals[pos] = attrib;
	    return true;
	}
    }	



    /**
       
       @return -2 if pos is invalid, else returns the value
    */
    public String getAttribVal(int pos){
	//System.out.println("attributVals.length = " + attributeVals.length);
	//for (int i = 0; i < attributeVals.length; i++)
	//    System.out.print(attributeVals[i]);
	//System.out.println();
	if ((pos <0) || (pos >= attribVals.length)){
	    return "-2";
	}
	else{
	    if (attribVals == null)
		System.out.println("here in my problem");
	    return attribVals[pos];
	}
    }
	

    public String toString(){
	String s = "";

	long st = System.currentTimeMillis();
	/*
	for(int i = 0; i <attribVals.length; i++){
	    s = s.concat(attribVals[i]);
	    if (i < (attribVals.length - 1))
		s = s.concat(",");
	    if ((i % 2000) == 0)
		System.out.println("done " + i);
	}*/
	for(int i = 0; i <attribVals.length - 1 ; i++){
	    s += attribVals[i] + ",";
	    /*
	    if (i < (attribVals.length - 1))
		s = s.concat(",");
	    */
	    if ((i % 2000) == 0)
		System.out.println("done " + i);
	}
	long end = System.currentTimeMillis();
	System.out.println("this took " + (end - st));
	s += attribVals[attribVals.length -1];
	//s = s.concat("classification is " + classification);
	
	return s;
    }


    /**
       @param positions is a indexinto the attributes to be used in making
              the string

       @return a string which is a subset of the attributes in 
    */
    public String toString(int[] positions){
	String s = "";
	for(int ix = 0; ix < positions.length - 1; ix++){
	    s = s + attribVals[positions[ix]]  + ","; 
	    
	}
	
	s = s + attribVals[positions[positions.length - 1]];

	return s;
    }


    /**
       returns the feature value has position
    */
    public final String getValue(int pos){
	return attribVals[pos];
    }

    /**
       if you know you have a continuous attribute
       @return 
    */
    public final double getConValue(int pos){
	return conVals[pos];
    }

    public final void convertVals(Datapairs[] attributes){
	
	for(int ix = 0; ix < attribVals.length; ix++){
	    if (attributes[ix].isContinuous()){
		conVals[ix] = Double.parseDouble(attribVals[ix]);
	    }
	}
	
    }
    /**
       @return the the number of features (including classification) that define
               an example
       
     */
    public int numValues(){
	return attribVals.length;
    }

 
}//end class DataElement













