package sayu;
/**
   @author Mark Goadrich
   This class represent the number of true and false positives covere by a given classifier.  It is used for correctly interpolating in Precision Recall Space. 
*/

public class MyPoint implements Comparable{

    //the number of false positives covered.
    private int neg = 0;
    //the number of true positives covered 
    private int pos = 0;

    /**
       This class represent the number of true and false positives covere by a given classifier.  It is used for correctly interpolating in Precision Recall Space. 
       @param pos the number of true positives covered 
       @param neg the number of false positives covered.
    */
    public MyPoint(int pos, int neg){
	this.neg = neg;
	this.pos = pos;
    }

    /**
       @return the number of false positives covered.
    */
    public int getNeg(){
	return neg;
    }//end of method getNeg();

    /**
       @return the number of true positives covered 
    */
    public int getPos(){
	return pos;
    }//end of method getPos();

    /**
       @param o is of type MyPoint
       @return -1 if o covers more positive than this object.  0 if o covers the same number of positive examples as this object does. 1 if this covers more positive than o.
    */
    public int compareTo(Object o){
	MyPoint p = (MyPoint) o;
	int tmpPos = p.getPos();
	if (tmpPos > pos){
	    return -1;
	}
	else if (tmpPos < pos){
	    return 1;
	}
	else{
	    return 0;
	}
    }//end of method compareTo
}//end of class MyPoint
