package sayu;
import java.util.*;

public class TPRComparator implements Comparator{

    /**
       Performs a comparision based on TPR (or recall).
       @param o is of type ROCPoint
       @return -1 if this.getTPR() < o.getTPR(). 0 if o.getTPR() == this.getTPR(). 1 if this.getTPR() > o.getTPR()
     */
    public int compare(Object o1, Object o2){
        ROCPoint tmp1 = (ROCPoint)o1;
        ROCPoint tmp2 = (ROCPoint)o2;
        double tpr1 = tmp1.getTPR();
        double tpr2 = tmp2.getTPR();
        if (tpr1 < tpr2){
            return -1;
        }
        else if (tpr1 > tpr2){
            return 1;
        }
        else{
            double prec1 = tmp1.getPrecision();
            double prec2 = tmp2.getPrecision();
            if (prec1 < prec2){
                return -1;
            }
            else if (prec1 > prec2){
                return 1;
            }
            else{
                return 0;
            }
        }
    }//end of method tprComp(Object o);

}
