
:- module(retrain_model,[retrain_model/0]).

:- use_module(scorer,[
		      mark_committed/1,
		      renew_object/0,
		      covers_example/4,
		      scoring_data/4,
		      new_feature/5,
		      init_scoring/1
		     ]).


retrain_model :-
	renew_object,
	redo_clauses.

redo_clauses :-
	recorded(theory_clause, Clause, _),
	score_clause(Clause, Score),
	mark_committed(Score),
	fail.
redo_clauses.

score_clause(Clause, Score) :-
	scoring_data(TrPos, TrNeg, TePos, TeNeg),
	gen_bmap(Clause, train, pos, TrPos),
	gen_bmap(Clause, train, neg, TrNeg),
	gen_bmap(Clause, test, pos, TePos),
	gen_bmap(Clause, test, neg, TeNeg),
	new_feature(TrPos, TrNeg, TePos, TeNeg, Score).

gen_bmap(Clause,Type,PosNeg,Obj) :-
	init_scoring(Obj),
	call_example(Type,PosNeg,Clause,Obj).

call_example(Type,PosNeg,(Ex :- Body),Obj) :-
	user:example(Id,Type,PosNeg,Ex),
	( call(user:Body) ->
	    covers_example(Obj, PosNeg, Type, Id)
	),
	fail. 
call_example(_,_,_,_).

	

