
:- module(vista_constants,[get_constants/2,
	get_constant/4,
	init_constants/0,
	constants_from_bottom_clauses/1]).

:- use_module(bottom_clause,[constants_from_an_example/4,
	constant_from_bcs/3]).

:- use_module(correlation,[
	extra_constant/4]).

:- use_module(reduce,[current_example/2]).

:- use_module(library(lists),[member/2]).

:- use_module(demand_constant,[demand_constant/4]).

:- dynamic constants_from_bottom_clauses/1.

constants_from_bottom_clauses(false).

:- dynamic demand_constants/1.

demand_constants(false).

:- dynamic min_constants_from_bottom_clauses/1.
min_constants_from_bottom_clauses(1).

:- dynamic correlation_file/1.

correlation_file('corrs.yap').

%
%
%
get_constants(Type, ArgHeadList) :-
	constants_from_bottom_clauses(true), !,
	current_example(Id, PosNeg),
	constants_from_an_example(Id, PosNeg, Type, ArgHeadList).
get_constants(Type, ArgHeadList) :-
	Goal =.. [Type, X],
	findall(X, call(user:Goal), ArgHeadList).

get_constant(Consts, ClauseInfo, Type, Constant) :-
	demand_constants(true), !,
	demand_constant(Consts, Type, ClauseInfo, Constant).
get_constant(Consts, _, _Type, Constant) :-
	constants_from_bottom_clauses(true), !,
	setof(X,c_for_set(Consts,X), Els),
	member(Constant, Els),
	\+ member(Constant, Consts).
get_constant(_, _, Type, Constant) :-
	Goal =.. [Type, Constant],
	call(user:Goal).

init_constants :-
	constants_from_bottom_clauses(true),
	\+ demand_constants(true), !,
	correlation_file(CORRELATION_FILE),
	ensure_loaded(CORRELATION_FILE).
init_constants.

c_for_set(C._ ,X) :- 
	correlation(C,X,Corr), 
	abs(Corr) >= 0.5.
c_for_set(C._, X) :- 
	correlation(X,C,Corr), 
	abs(Corr) >= 0.5.
c_for_set(_.Consts,X) :- 
	c_for_set(Consts,X).
