:- module(vista_heap,[init_heap/0,
		      add_to_heap/2,
		      get_from_heap/1,
		      close_heap/0]).

:- use_module(library(nb)).

%
% make heap search the default search.
%

init_heap :-
	close_heap,
	fail.
init_heap :-
	nb_heap(1024,Heap),
	nb_setval(heap, Heap).

close_heap :-
	catch(nb_getval(heap, Heap),_,fail),
	nb_heap_close(Heap),
	nb_delete(heap).

add_to_heap(K,V) :-
	nb_getval(heap, Heap),
	nb_heap_add(Heap, K, V).

get_from_heap(V) :-
	nb_getval(heap, Heap),
	nb_heap_del(Heap, _, V).
