
:- module(vista_prune,[doprune/1]).

:- use_module('../common/debug_write',[debug_format/3]).

:- use_module(goals,[diff_goals/3]).

:- use_module(library(terms), [variable_in_term/2]).
doprune(_) :- !, fail.
doprune((_ :- G)) :-
	\+ diff_goals(G, [], _), !,
	debug_format(2,' diff_goals pruning: ~n',[]).
doprune((H1 :- (A,B))) :-
	H1 =.. [_,V1,V2],
	(\+ variable_in_term((A,B), V1)
	;
	\+ variable_in_term((A,B), V2)), !,
	debug_format(2,' var_in_term pruning: ~n',[]).
doprune((H1 :- (A,B))) :-
	H1 =.. [_,V1,V2,_],
	(\+ variable_in_term((A,B), V1)
	;
	\+ var_in_term((A,B), V2)), !,
	debug_format(2,' var_in_term pruning: ~n',[]).
doprune((H :- G)) :-
	current_predicate(user:prune,prune(_)),
	user:prune((H :- G)), !.

