:- module(vista_queue,[init_queue/0,
		      add_to_queue/2,
		      get_from_queue/1,
		      close_queue/0]).

:- use_module(library(nb)).

%
% make queue search the default search.
%

init_queue :-
	close_queue,
	fail.
init_queue :-
	nb_queue(Queue),
	nb_setval(queue, Queue).

close_queue :-
	catch(nb_getval(queue, Queue),_,fail),
	nb_queue_close(Queue),
	nb_delete(queue).

add_to_queue(K,V) :-
	nb_getval(queue, Queue),
	nb_queue_enqueue(Queue, K, V).

get_from_queue(_,V) :-
	nb_getval(queue, Queue),
	nb_queue_dequeue(Queue, _, V).
